<template>
  <section ref="parent">
    <h1>HP Leiste</h1>

    <p>
      <label>
        HP:
        <input v-model.number="value" type="number" min="0" :max="maxValue" />
      </label>
    </p>
  </section>
</template>

<script>
import Game from '~/lib/game'
import HpScene from '~/lib/hp-scene'

export default {
  name: 'HPExample',

  data() {
    return {
      value: 10,
      maxValue: 1000
    }
  },

  computed: {
    barStyle() {
      return `height: 10px; width: ${(this.barWidth *
        Math.min(this.maxValue, this.value)) /
        this.maxValue}px; background-color: green;`
    }
  },

  watch: {
    value(newValue) {
      this.scene.setCurrentValue(newValue)
    }
  },

  mounted() {
    const { parent } = this.$refs
    this.game = new Game({ parent })

    this.scene = new HpScene({
      x: 50,
      y: 100,
      width: 200,
      height: 10,
      lineWidth: 2,
      maxValue: this.maxValue
    })
    this.game.scene.add('bar', this.scene, true)

    this.game.events.once('ready', () => {
      this.scene.setCurrentValue(this.value)
    })
  }
}
</script>

<style>
canvas {
  margin-top: 50px;
}
</style>
